/*
 * Copyright (C) 2010,2012  Dzuy Nguyen Avidz LLC
 *
 * This file is part of miad.
 *
 * miad is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * miad is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with miad.  If not, see <http://www.gnu.org/licenses/>.
*/
var allowBG="green";
var blockBG="red";
var lGrey="#f3f3f3";
var dGrey="#d4d4d4";
var lBlue="#e2eaf8";
var dBlue="#83A1c1";
var isIE=document.all;
var drag=false;

var mia=null;
function miaInit(getUri,saveUri,divObj){
    mia=new miaUI(getUri,saveUri,divObj);
    mia.init();
}

function loadAccess(txtResp,xmlResp){
    mia.access=JSON.parse(txtResp);
    mia.createList();
    mia.createButtons();
}
function miaUI(getUri,saveUri,divObj){
    this.getUri=getUri;
    this.saveUri=saveUri;
    this.access=null;
    this.macaddr=null;
    this.pTbl=new profileTable();
    this.parentDiv=divObj;

    this.init=function(){
        this.policyDiv=miaElement("div");
        this.parentDiv.appendChild(this.policyDiv);
        this.listDiv=document.createElement("div");
        this.parentDiv.appendChild(this.listDiv);
        this.btnDiv=document.createElement("div");
        this.parentDiv.appendChild(this.btnDiv);
        this.editDiv=document.createElement("div");
        this.parentDiv.appendChild(this.editDiv);
        post(this.getUri,"",loadAccess,null);
        post("/cgi-bin/getmac.cgi","",this.loadMAC,null);
    },
    this.loadMAC=function(txtResp,xmlResp){
        mia.macaddr=txtResp;
    }
    this.getMAC=function(){
        document.getElementById("mia_mac").value=this.macaddr;
    }
    this.refresh=function(){
        window.location.reload();
    }
    this.createButtons=function(){
        if(this.btnDiv.firstChild==null) {
            this.btnDiv.appendChild(miaInput(
               {value:" New ",type:"button",id:"new_btn",onclick:function(){mia.createEditBox()}}));
            this.btnDiv.appendChild(miaInput(
               {value:" Save ",type:"button",id:"sav_btn",disabled:true,onclick:function(){mia.submitProfile()}}));
            this.btnDiv.appendChild(miaInput(
               {value:" Cancel ",type:"button",id:"can_btn",disabled:true,onclick:function(){mia.refresh()}}));
        }
    }
    this.createList=function(){
        var polSel=miaDropdown(
            [" Allow all "," Block all "],this.getPolicy());
        polSel.id="mia_policy";
        polSel.onchange=function(){mia.toggleSave(false)};
        this.policyDiv.innerHTML="<b>Policy:</b> ";
        this.policyDiv.appendChild(polSel);
        var pt=new miaTable({width:"100%"});
        pt.style.borderCollapse="collapse";
        pt.tHead.style.backgroundColor=lBlue;
        var hdrRow=pt.tHead.insertRow(-1);
        applyFont(hdrRow.style);
        var hdrs=["ID","Name","Access","Delete"];
        for(var h=0; h<hdrs.length; h++){
            var hdrCell=hdrRow.insertCell(-1);
            hdrCell.style.backgroundColor=lBlue;
            hdrCell.style.fontWeight="bold";
            hdrCell.innerHTML=hdrs[h];
        }
        for(var i=0; i<this.access.profiles.length; i++){
            var dataRow=pt.insertRow(-1);
            applyFont(dataRow.style);
            dataRow.id=this.access.profiles[i].id;
            dataRow.onclick=function(){mia.editProfile(this.rowIndex-1)};
            var idCell=dataRow.insertCell(-1);
            idCell.innerHTML=this.access.profiles[i].id;
            var nameCell=dataRow.insertCell(-1);
            nameCell.innerHTML=this.access.profiles[i].name;
            var acCell=dataRow.insertCell(-1);
            var ac=(this.access.profiles[i].tb==null)?"unlimited":"limited";
            acCell.innerHTML=ac;
            var actCell=dataRow.insertCell(-1);
            var delBtn=document.createElement("img");
            delBtn.src="trash.png";
            delBtn.onclick=function(){mia.deleteProfile(this)};
            actCell.appendChild(delBtn);
        }
        var oldChild=this.listDiv.firstChild;
        (oldChild==null) ? this.listDiv.appendChild(pt):this.listDiv.replaceChild(pt,oldChild);
        this.applyBG();
    },
    this.createEditBox=function(eObj){
        var fs=document.createElement("fieldset");
        var lg=miaElement("legend");
        lg.style.color="blue";
        fs.appendChild(lg);
        var frmTbl=new miaTable();
        fs.appendChild(frmTbl);
        var labels=["MAC:","Name:","Access:",""];
        for(var i=0;i<labels.length;i++){
            var row=frmTbl.insertRow(-1);
            applyFont(row.style);
            var c0=row.insertCell(-1); 
            c0.innerHTML="<b>"+labels[i]+"</b>";
            row.insertCell(-1); 
        }
        var schedRow=frmTbl.insertRow(labels.length-1);
        var schedCell=schedRow.insertCell(-1);
        schedCell.id="mia_sched";
        schedCell.colSpan="2";
        var applyBtn=miaInput({type:"button",value:" Apply "});
        var resetBtn=miaInput({type:"button",value:" Reset "});
        frmTbl.rows[4].cells[1].appendChild(applyBtn);
        frmTbl.rows[4].cells[1].appendChild(resetBtn);
        var oldChild=this.editDiv.firstChild;
        (oldChild==null)?this.editDiv.appendChild(fs):this.editDiv.replaceChild(fs,oldChild);
        var acl=0;
        if(eObj!=null){
            lg.innerHTML=" <b>Edit Profile</b> ";
            frmTbl.rows[0].cells[1].innerHTML=eObj.id;
            frmTbl.rows[0].cells[1].appendChild(miaInput(
               {id:"mia_mac",value:eObj.id,type:"hidden"}));
            frmTbl.rows[1].cells[1].appendChild(miaInput(
               {id:"mia_name",value:eObj.name}));
            applyBtn.onclick=function(){mia.applyForm(false)};
            resetBtn.onclick=function(){mia.createEditBox(eObj)};
            if(eObj.tb==null){
                acl=1;
            }else{
                schedCell.appendChild(this.pTbl.getTable());
                this.applyProfile(eObj.tb);
            }
        }else{
            lg.innerHTML=" <b>New Profile</b> ";
            frmTbl.rows[0].cells[1].appendChild(miaInput(
                {id:"mia_mac",ondblclick:function(){mia.getMAC()}}));
            frmTbl.rows[0].cells[1].appendChild(miaInput(
                {type:"button",value:" This computer ",onclick:function(){mia.getMAC()}}));
            frmTbl.rows[1].cells[1].appendChild(miaInput({id:"mia_name"}));
            schedCell.appendChild(this.pTbl.getTable());
            applyBtn.onclick=function(){mia.applyForm(true)};
            resetBtn.onclick=function(){mia.pTbl.resetProfile()};
        }
        var aclSel=miaDropdown(
            [" Limited "," Unlimited "],acl);
        aclSel.id="mia_acl";
        aclSel.onchange=function(){mia.checkAcl(this.value)};
        frmTbl.rows[2].cells[1].appendChild(aclSel);
    },
    this.applyProfile=function(tb){
        for(var i=0;i<tb.length;i++){
            for(var j=0; j<tb[i].length; j++){
                var h=tb[i][j][0];
                var t=tb[i][j][1];
                for(var k=0;k<t;k++){
                    var s=parseInt(h+k);
                    var block=document.getElementById("mia_d"+i+"h"+s);
                    block.style.backgroundColor=allowBG;
                }
            }
        }
        this.pTbl.isDirty(true);
    },
    this.getPolicy=function(){
        return this.access.policy=="allow"?0:1;
    },
    this.submitProfile=function(){
        var policy=document.getElementById("mia_policy").value;
        this.access.policy=(policy==0)?"allow":"block";
        var params=escape(JSON.stringify(this.access)); 
        post(this.saveUri,params,this.refresh,null) 
    },
    this.applyBG=function(idx){
        var tbl=this.listDiv.firstChild;
        var emac=document.getElementById("mia_mac");
        var bg=dGrey;
        for(var i=1;i<tbl.rows.length;i++){
            bg=(bg==lGrey)?dGrey:lGrey;
            tbl.rows[i].style.backgroundColor=bg;
            if((emac!=null)&&(emac.value==tbl.rows[i].id)){
                tbl.rows[i].style.backgroundColor="#fff7b4";
            }
        }
    }
    this.applyForm=function(isNew){
        var id=trim(document.getElementById("mia_mac").value);
        if(id==""){
            alert("Please fill in the MAC address");
            return;
        }
        id=id.toUpperCase().replace(/-/g,':');
        if(!id.match(/\w\w:\w\w:\w\w:\w\w:\w\w:\w\w/)) {
            alert("Invalid MAC address");
            return;
        }
        var name=document.getElementById("mia_name").value;
        var acl=document.getElementById("mia_acl").value;
        var tb=(acl==0)?getBlockProfile():null;
        var profile=this.findProfile(id);
        if(isNew){
            if(profile!=null){
                alert("This profile ID already exists ("+ profile.name + ")!");
                return;
            }
            this.access.profiles.push({id:id,name:name,tb:tb});
        }else{
            if(profile!=null){
                profile.name=name;
                profile.tb=tb;
            }
        }
        this.editDiv.removeChild(this.editDiv.firstChild);
        this.createList();
        this.toggleSave(false);
    }
    this.findProfile=function(id){
        for(var i=0;i<this.access.profiles.length;i++){
            if(this.access.profiles[i].id==id)
                return this.access.profiles[i];
        }
        return null;
    }
    this.editProfile=function(idx){
        if(idx<0)
            return;
        this.createEditBox(this.access.profiles[idx]);
        this.applyBG(idx);
    },
    this.toggleSave=function(dis){
        var sav=document.getElementById("sav_btn");
        var cancel=document.getElementById("can_btn");
        sav.disabled=dis;
        cancel.disabled=dis;
        if(dis==false)
            sav.style.backgroundColor="#f6d420";
    }
    this.deleteProfile=function(obj){
        var idx=obj.parentNode.parentNode.rowIndex;
        var edit=document.getElementById("mia_mac");
        if((edit!=null)&&(this.access.profiles[idx-1].id==edit.value)) 
            this.editDiv.removeChild(this.editDiv.firstChild);
        this.access.profiles.splice(idx-1,1);
        this.listDiv.firstChild.deleteRow(idx);
        this.applyBG();
        this.toggleSave(false);
    },
    this.checkAcl=function(val){
        var sched=document.getElementById("mia_sched");
        if(val==0){
            if(sched.firstChild==null)
                sched.appendChild(this.pTbl.getTable());
        }else{
            sched.removeChild(sched.firstChild); 
        }
    }
}
function keyExists(obj,key){
    for(var i in obj){
        if(i==key)
            return true;
    }
    return false;
}
flipColor=function(obj){
    var s=obj.style;
    s.backgroundColor=(s.backgroundColor==allowBG)?blockBG:allowBG;
}
function profileTable(){
    this.tbl=null;
    this.bBtn=null;
    this.fBtn=null;
    this.show=1;
    this.dirty=false;

    this.createTable=function(){
        var weekDays=["Sun","Mon","Tues","Wed","Thur","Fri","Sat"];
        var date=new Date();
        var today=date.getDay();
        var hour=date.getHours();
        this.tbl=new miaTable();
        var cap=this.tbl.createCaption();
        this.bBtn=miaInput(
           {type:"button",value:" << ",id:"mia_back",onclick:function(){mia.pTbl.shiftSched(-1)}});
        this.bBtn.style.height="19px";
        this.fBtn=miaInput(
           {type:"button",value:" >> ",id:"mia_fwd",disabled:false,onclick:function(){mia.pTbl.shiftSched(1)}});
        this.fBtn.style.height="19px";
        cap.appendChild(this.bBtn);
        applyFont(cap.style);
        cap.appendChild(document.createTextNode(" Daily Internet Schedule "));
        cap.appendChild(this.fBtn);
        this.tbl.style.borderCollapse="collapse";
        var hdrRow=this.tbl.tHead.insertRow(-1);
        applyFont(hdrRow.style);
        var timeHdr=hdrRow.insertCell(-1);
        hdrRow.style.backgroundColor=lBlue;
        timeHdr.align="right";
        timeHdr.innerHTML="<b>Time:</b>";
        for(var i=0; i<24; i++){
            var m="AM";
            var hr=i;
            if(hr >=12){
                hr-=12;
                m="PM";
            }
            if(hr==0) 
                hr=12;
            var timeCell=hdrRow.insertCell(-1);
            timeCell.style.fontSize="10px";
            timeCell.setAttribute("align","center");
            if(hour==i) 
                timeCell.style.backgroundColor=dBlue;
            timeCell.innerHTML="<b>"+hr+":00 "+m+"</b>";
            timeCell.style.width="27px";
            timeCell.style.border="1px solid black";
        }
        for(var j=0;j<weekDays.length;j++){
            var dayRow=this.tbl.insertRow(-1);
            dayRow.onmousedown=function(){drag=true};
            dayRow.onmouseup=function(){drag=false};
            var dayCell=dayRow.insertCell(-1);
            applyFont(dayCell.style);
            (today==j)?dayCell.style.backgroundColor=dBlue:dayCell.style.backgroundColor=lGrey;
            dayCell.setAttribute("align","right");
            dayCell.innerHTML="<b>"+weekDays[j]+": </b>";
            var bCell=null;
            for(var k=0;k<48;k++){
                var bSpan=document.createElement("span");
                bSpan.id="mia_d"+j+"h"+k;
                var title=weekDays[j]+" ";
                title+=(k%2==0)?k/2+":00":(k-1)/2+":30";
                bSpan.title=title;
                bSpan.style.backgroundColor=blockBG;
                bSpan.style.height="19px";
                bSpan.onmouseover=function(){if(drag) flipColor(this)};
                bSpan.onmousedown=function(){flipColor(this)};
                bSpan.style.paddingRight="13px";
                if((k%2)==0){
                    bSpan.style.marginRight="1px";
                    bCell=dayRow.insertCell(-1);
                    bCell.style.border="1px solid black";
                }
                bCell.appendChild(bSpan);
            }
        }
    },
    this.resetProfile=function(){
        for(var i=1;i<this.tbl.rows.length;i++){
            for(var j=1;j<this.tbl.rows[i].cells.length;j++){
               this.tbl.rows[i].cells[j].firstChild.style.backgroundColor=blockBG;
               this.tbl.rows[i].cells[j].lastChild.style.backgroundColor=blockBG;
            }
        }
        this.dirty=false;
    }
    this.getTable=function(){
        if(this.tbl==null)
            this.createTable();
        if(this.dirty)
            this.resetProfile();
        this.shiftSched(1);
        return this.tbl;
    }
    this.shiftSched=function(dir){
        var vis=(isIE)?"inline":"table-cell";
        for(var i=0;i<this.tbl.rows.length;i++){
            for(var j=1;j<this.tbl.rows[i].cells.length;j++){
                if(dir==1){
                    this.tbl.rows[i].cells[j].style.display=(j>9)?vis:"none";
                    this.fBtn.disabled=true;
                    this.bBtn.disabled=false;
                }else if(dir==-1){
                    this.tbl.rows[i].cells[j].style.display=(j>15)?"none":vis;
                    this.fBtn.disabled=false;
                    this.bBtn.disabled=true;
                }
            }
        }
        this.show=dir;
    }
    this.isDirty=function(dirt){
        this.dirty=dirt;
    }
}
getBlockProfile=function(){
    var profile=new Array();
    for(var i=0;i<7;i++){
        profile[i]=new Array();
        var t=-1;
        var h=0;
        for(var j=0;j<48;j++){
            var block=document.getElementById("mia_d"+i+"h"+j);
            if(block==null)
                return null;
            if(block.style.backgroundColor!=blockBG){
                if(t==-1)
                    t=j;
                h+=1;
            }else{
                if(t==-1){
                    continue;
                }else{
                    profile[i].push([t,h]);
                    t=-1;
                    h=0;
                }
            }
        }
        if(t!=-1) 
            profile[i].push([t,h]);
    }
    return (profile.length>0)?profile:null;
}
function miaElement(tag){
    var ele=document.createElement(tag);
    ele.style.padding="0 10px 10px 0";
    applyFont(ele.style);
    return ele;
}
function applyFont(styleObj){
    if(styleObj!=null){
        styleObj.fontFamily="Arial,Helvetica,sans-serif";
        styleObj.fontSize="12px";
    }
}
function miaTable(props){
    var tbl=document.createElement("table");
    tbl.cellpadding=0;
    tbl.cellspacing=0;
    tbl.border=0;
    for(var i in props){
        tbl[i]=props[i];
    }
    tbl.createTHead();
    var body=document.createElement("tbody");
    tbl.appendChild(body);
    return tbl;
}
function miaInput(props){
    var inp=document.createElement("input");
    applyFont(inp.style);
    inp.style.margin="0 2px 0 2px";
    for(var i in props){
        if(i=="label"){
            var lbl=document.createTextNode(props[i]);
            continue;
        }
        inp[i]=props[i];
    }
    return inp;
}
miaDropdown=function(options,def){
    var list=document.createElement("select");
    applyFont(list.style);
    for(var i=0;i<options.length;i++){
        var opt=document.createElement("option");
        opt.value=i;
        opt.innerHTML=options[i];
        if(i==def) 
            opt.selected=true;
        list.appendChild(opt);
    }
    return list;
}
function trim(str){
    return str.replace(/^\s\s*/,'').replace(/\s\s*$/,'');
}
